/////////////////////////////////////////////////////////////////////////////////////
// This file is part of the POEngine library, part of the PngOptimizer application
// Copyright (C) 2002/2011 Hadrien Nilsson - psydk.org
// For conditions of distribution and use, see copyright notice in PngOptimizer.h
/////////////////////////////////////////////////////////////////////////////////////
#ifndef POENGINE_POENGINESETTINGS_H
#define POENGINE_POENGINESETTINGS_H

using namespace chustd;

///////////////////////////////////////////////////////////////////////////////////////////////////
enum POChunkOption
{
	POChunk_Remove,
	POChunk_Keep,
	POChunk_Force
};

///////////////////////////////////////////////////////////////////////////////////////////////////
// Settings for POEngine
struct POEngineSettings
{
	// Settings, directly read/written by the application
	bool backupOldPngFiles;
	bool keepInterlacing;
	bool avoidGreyWithSimpleTransparency;
	bool ignoreAnimatedGifs;
	bool keepFileDate;

	POChunkOption bkgdOption;
	Color32       bkgdColor; // Forced color

	POChunkOption textOption;
	String        textKeyword; // Forced text keyword
	String        textData;    // Forced text data

	POEngineSettings();
	void LoadFromIni(const MemIniFile& ini);
	void LoadFromArgv(const ArgvParser& ap);
	void SaveToIni(MemIniFile& ini);

	static void WriteArgvUsage(const String& indent);
};

#endif
