///////////////////////////////////////////////////////////////////////////////
// This file is part of the chustd library
// Copyright (C) 2005/2011 ChuTeam
// For conditions of distribution and use, see copyright notice in chustd.h
///////////////////////////////////////////////////////////////////////////////

#ifndef CHUSTD_CONSOLE_H
#define CHUSTD_CONSOLE_H

namespace chustd {

class String;

class Console  
{
public:
	Console();
	virtual ~Console();

	static void WriteLine(const chustd::String& str);
	static void Write(const chustd::String& str);

	// Gets an input string from the user. The user must validate its data with the  Enter  key.
	// Returns true if an input string could be get
	static bool WaitForInput(chustd::String& str);

	// strPrompt : string shown before user input characters
	static bool WaitForInput(const chustd::String& strPrompt, chustd::String& strInput);

	// Gets a character from the user.
	// Returns the unicode code point of the corresponding pressed key
	static uint32 WaitForKey();
};

} // namespace chustd

#endif // ndef CHUSTD_CONSOLE_H
