///////////////////////////////////////////////////////////////////////////////
// This file is part of the chustd library
// Copyright (C) 2005/2011 ChuTeam
// For conditions of distribution and use, see copyright notice in chustd.h
///////////////////////////////////////////////////////////////////////////////

#ifndef CHUSTD_FILEPATH_H
#define CHUSTD_FILEPATH_H

#include "String.h"

namespace chustd {

class FilePath
{
public:
	// Adds a separator to a path if necessary
	static String AddSeparator(const String& dir, wchar cModel = '/');

	static String Combine(const String& part1, const String& part2);

	// Adds a prefix to a filename within a path : /foo/bar/filename.txt -> /foo/bar/prefix-filename.txt
	static String AddFileNamePrefix(const String& path, const String& prefix);

	// Removes the extension of a file name in a file path
	static String RemoveExtension(const String& path); // NOTE: Removes the '.'

	// Splits a path into its directory part and file name part
	static void Split(const String& path, String& dir, String& fileName);
};

//////////////////////////////////////////////////////////////////////////////////////////////////////

} // namespace chustd

#endif
