///////////////////////////////////////////////////////////////////////////////
// This file is part of the chustd library
// Copyright (C) 2005/2011 ChuTeam
// For conditions of distribution and use, see copyright notice in chustd.h
///////////////////////////////////////////////////////////////////////////////

#ifndef CHUSTD_IMAGELOADER_H
#define CHUSTD_IMAGELOADER_H

namespace chustd {

class ImageFormat;

// Loads the right imagetype
class ImageLoader
{
public:
	bool Load(const chustd::String& strFileName);
	bool LoadFromFile(IFile& file);
	bool Instanciate(IFile& file);
	bool InstanciateLosslessFormat(IFile& file);

	ImageLoader();
	~ImageLoader();

public:
	ImageFormat* m_pImageType;
	enum Type
	{
		typeNone, typeBmp, typeGif, typePng, typeJpeg, typeTga
	};
	uint8 m_nType;
};

} // namespace chustd

#endif // ndef CHUSTD_IMAGELOADER_H
