///////////////////////////////////////////////////////////////////////////////
// This file is part of the chuwin32 library
// Copyright (C) 2005/2008 ChuTeam
// For conditions of distribution and use, see copyright notice in chuwin32.h
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Dialog.h"

///////////////////////////////////////////////////////////////////////////////
using namespace chuwin32;
///////////////////////////////////////////////////////////////////////////////

LRESULT Dialog::DlgProc(UINT nMsg, WPARAM wParam, LPARAM /*lParam*/)
{
	// Default behaviour
	if( nMsg == WM_COMMAND )
	{
		int nId = LOWORD(wParam);
		switch( nId ) 
		{
		case IDCANCEL:
		case IDOK:
			EndDialog(nId);
			return TRUE;
		}
	}
	return FALSE;
}

LRESULT CALLBACK Dialog::DlgProcStatic(HWND hDlg, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
	Dialog* pDlg = NULL;

	// LPARAM contient un pointeur sur la dialogbox qui a appel
	// la fonction de cration de la bote de dialogue
	// on en profite donc pour appeler l'vnement WM_INITDIALOG
	// dfini par l'utilisateur dans sa classe drive de CDialog
	if( nMsg == WM_INITDIALOG )
	{
		pDlg = (Dialog*) lParam;
		ASSERT(pDlg != NULL);
		
		// La fentre a t correctement cre
		// Fixe le pointeur de la fentre pour les autres messages
		::SetWindowLongPtr(hDlg, DWLP_USER, LONG_PTR(pDlg));
		
		// Fixe le handler de la fentre
		pDlg->m_hWnd = hDlg;
	}
	else
	{
		LONG_PTR nLong = ::GetWindowLongPtr(hDlg, DWLP_USER);
		pDlg = (Dialog*) (nLong);
	}

	if( pDlg != NULL )
	{
		return pDlg->DlgProc(nMsg, wParam, lParam);
	}
	return FALSE;
}

int Dialog::DoModalHelper(HINSTANCE hInstance, int nDialogId, HWND hParent)
{
	INT_PTR nResult = DialogBoxParamW(hInstance, 
		MAKEINTRESOURCE(nDialogId),
		hParent,
		(DLGPROC) DlgProcStatic,
		PtrToUlong(this)
		);
	return int(nResult);
}

bool Dialog::CreateModelessHelper(HINSTANCE hInstance, int nDialogId, HWND hParent)
{
   m_hWnd = CreateDialogParam(hInstance, 
      MAKEINTRESOURCE(nDialogId),
      hParent,
      (DLGPROC) DlgProcStatic,
      PtrToUlong(this)
      );
   return m_hWnd != NULL;
}
